# Blender Primer #

# Introduction to Blender #

A complete description of Blender is beyond the scope of this documentation.
For an in depth introduction to Blender, the [Blender 3D: Noob to Pro](https://en.wikibooks.org/wiki/Blender_3D:_Noob_to_Pro)
wikibook covers almost every aspect and the internet is full of tutorials on how to achieve specific effects.
Nontheless a quick "cheat sheet" like introduction is given here.

## Scene Graph ##

In Blender all entities such as lights and meshes are encapsulated by objects.
If an object with a mesh or curve is selected, the Tab-key switches between the
Object Mode, in which objects can be selected and rearranged, and the
edit mode, in which the selected (or, to be more precise, the active) mesh or curve can be edited.

Objects have an orientation and location and can build hierarchies.
For example, an object containing the mesh of a lamp can be parent to an
object containing a light. Whenever the parent is moved or rotated, the child
inherits this transformation.
Objects can also be "Empty", as in not contain a mesh, light, curve, camera, etc.
These are useful for building the aforementioned hierarchies.

Objects can form Groups, which are templates that can be instantiated. Changing the elements of
a group affects all instances.

## UI ##

* Focus is always where the cursor is (not what was last clicked)
* Frames can be split and joined
* DropDown menu to change editor type
* Side panes can be opened by clicking the (+) 
* Selection vs Activation:
    + None, one, or multiple objects can be selected
    + Selection via right click (multiple selection via shift+right click)
    + Only the last object is active (even if multiple objects are selected)
    + Tab-key switches to the edit mode of the active object
    + Properties apply to active object only

## Cycles and Materials ##

* Cycles is a monte carlo path tracer
* Materials are build in the Node Editor
* Complex material/light interactions require many samples/iterations

## Important Hotkeys ##

The full list can be inspected (and changed) in the User Preferences under "Input". The following are arguably the most important ones.

|  Short Cut           |    Action             |
|----------------------|:----------------------|
| Middle Click         | Rotate View           |
| Shift+Middle Click   | Translate View        |
| Mouse Wheel          | Zoom View             |
| Ctrl+Middle Click    | Zoom View             |
| Numpad 7             | View from Top         |
| Numpad 1             | View from Front       |
| Numpad 3             | View from Side        |
| Numpad 0             | View from Active Camera |
| Numpad 5             | Toggle Orthographic/Perspective View |
| Numpad 8 4 6 2       | Rotate View           |
| | |
| a  | Select all / none                |
| (Shift+)Right Click  | Select                |
| a  | (De)Select all                |
| b                    | Box Select                |
| c                    | Circle Select (Mouse Wheel for size) |
| g                    | Move selection (right click for abort, left click for commit) |
| r                    | Rotate selection (right click for abort, left click for commit) |
| s                    | Scale selection (right click for abort, left click for commit) |
| Tab                  | Toggle edit/object mode  |
| | |
| H                    | Hide selection   |
| Alt+H                | Unhide everything |
| | |
| I                    | Insert Keyframe  |
| Ctrl+P                    | Make the active object the parent of the other selected objects |
| Ctrl+G                    | Make group out of selection  |
| | |
| Shift+A                | Add stuff (in Edit Mode restricted to meshes)  |
| Space                | Search for Operation  |
| Ctrl+W               | Save                  |
| | |
| F12               | Render (Esc for abort)                  |
| CTRL+B | Draw a rect to restrict rendering |
| CTRL+ALT+B | Clear rendering rect |


