# SyB3R # {#mainpage}

# About #

SyB3R (Synthetic Benchmark for 3D Reconstruction) is a framework that facilitates the creation
of synthetic test datasets for computer vision methods such as Structure from Motion and Multi-View Stereo,
but also for related topics such as feature matching.
![Motivation](../imgs/Motivation.png)
The framework aids in the use of Blender and Cycles for rendering photorealistic images alongside ground truth information
about geometry, location of the camera, etc.

The relative ease and affordability of synthetic, rendered images makes them a viable inital or supplementary datasource for
niche scenarios and specific tests for which a fully fledged experimental setup is not feasible.

# Getting Started #

1. Download (e.g. from [here](http://andreas-ley.com/projects/SyB3R/) and unpack the source code.
2. Build according to the [Installation instructions](InstallationInstructions.md)
3. Download one of [our Blender scenes](#BlenderScenes) and [render it](PrepareAndRenderScene.md).
4. Run one of the example evaluations (see [Evaluations](Evaluation.md)), e.g., with (pmvs2)[http://www.di.ens.fr/pmvs/].

# Documentation #

* [Installation instructions](InstallationInstructions.md)
* [System overview](SystemOverview.md)
* [Introduction to Blender](BlenderPrimer.md)
* [Preparing and rendering a scene with blender](PrepareAndRenderScene.md)
* [The post processing chain](PostProcessingChain.md)
* [Evaluations](Evaluation.md)

# Blender Scenes # {#BlenderScenes}

* [Skull](http://andreas-ley.com/downloads/SyB3R/scenes/Skull_v1.0.zip)
* [Toad](http://andreas-ley.com/downloads/SyB3R/scenes/Toad_v1.0.zip)
* [Geological Specimen](http://andreas-ley.com/downloads/SyB3R/scenes/GeologicalSample_v1.0.zip)
* [Lego Bulldozer](http://andreas-ley.com/downloads/SyB3R/scenes/LegoBulldozer_v1.0.zip)

# Citation #

If SyB3R is used in your research, please cite:

    @Inbook{syb3r2016,
        author="Ley, Andreas and H\"ansch, Ronny and Hellwich, Olaf",
        editor="Leibe, B. and Matas, J. and Sebe, N. and Welling, M.",
        title="SyB3R: A Realistic Synthetic Benchmark for 3D Reconstruction from Images",
        bookTitle="Computer Vision - ECCV 2016",
        year="2016",
        publisher="Springer International Publishing",
        pages="236--251"
    }


# License #

    Syb3r - A framework for the creation and use of synthetic benchmark datasets for SfM/MVS with Blender and Cycles.
    Copyright (C) 2016 Andreas Ley <mail@andreas-ley.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

