#ifndef PLYPOINTCLOUDFILE_H
#define PLYPOINTCLOUDFILE_H

#include <string>
#include <fstream>
#include <functional>
#include <Eigen/Dense>

namespace syb3r {
namespace data {

class Pointcloud;

void importPLYPointcloudFile(Pointcloud &dst, const std::string &filename);
void importPLYPointcloudFile(Pointcloud &dst, std::fstream &inputStream);

void importPLYPointcloudFile(Pointcloud &dst, std::vector<float> &vertexQuality, const std::string &filename);
void importPLYPointcloudFile(Pointcloud &dst, std::vector<float> &vertexQuality, std::fstream &inputStream);

void writePLYPointcloudFile(const std::string &filename, unsigned numPoints, const std::function<void(unsigned, Eigen::Vector3f&)> &getPosition);
void writePLYPointcloudFile(std::fstream &dst, unsigned numPoints, const std::function<void(unsigned, Eigen::Vector3f&)> &getPosition);

void writePLYPointcloudFile(const std::string &filename, unsigned numPoints, const std::function<void(unsigned, Eigen::Vector3f&, Eigen::Vector3f&)> &getPositionNormal);
void writePLYPointcloudFile(std::fstream &dst, unsigned numPoints, const std::function<void(unsigned, Eigen::Vector3f&, Eigen::Vector3f&)> &getPositionNormal);

void writePLYPointcloudFile(const std::string &filename, unsigned numPoints, const std::function<void(unsigned, Eigen::Vector3f&, Eigen::Vector3f&, Eigen::Vector3f&)> &getPositionNormalColor);
void writePLYPointcloudFile(std::fstream &dst, unsigned numPoints, const std::function<void(unsigned, Eigen::Vector3f&, Eigen::Vector3f&, Eigen::Vector3f&)> &getPositionNormalColor);

void writePLYPointcloudFile(const std::string &filename, unsigned numPoints, const std::function<void(unsigned, Eigen::Vector3f&, Eigen::Vector3f&, std::uint32_t&)> &getPositionNormalColor);
void writePLYPointcloudFile(std::fstream &dst, unsigned numPoints, const std::function<void(unsigned, Eigen::Vector3f&, Eigen::Vector3f&, std::uint32_t&)> &getPositionNormalColor);

}
}

#endif // PLYPOINTCLOUDPARSER_H
