#include "Pointcloud.h"

namespace syb3r {
namespace data {

void Pointcloud::reset(unsigned numPoints)
{
    m_positions.clear();
    m_positions.resize(numPoints);
    m_normals.clear();
    m_normals.resize(numPoints);
    m_colors.clear();
    m_colors.resize(numPoints);

    m_visibilities.clear();
    m_visibilities.resize(numPoints);
    m_visibilityImageIndices.clear();
}

void Pointcloud::setPoint(unsigned index, const Eigen::Vector3f &position, const Eigen::Vector3f &normal)
{
    m_positions[index] = position;
    m_normals[index] = normal;
}

void Pointcloud::setPoint(unsigned index, const Eigen::Vector3f &position, const Eigen::Vector3f &normal, const Eigen::Vector3f &color)
{
    m_positions[index] = position;
    m_normals[index] = normal;
    m_colors[index] = color;
}

void Pointcloud::setPointVisibility(unsigned index, const unsigned *imageIndices, unsigned numImageIndices)
{
    m_visibilities[index].offset = m_visibilityImageIndices.size();
    m_visibilities[index].count = numImageIndices;

    for (unsigned i = 0; i < numImageIndices; i++)
        m_visibilityImageIndices.push_back(imageIndices[i]);
}

}
}
