#include "CameraProjectionMath.h"

namespace syb3r {
namespace math {

void RQDecompose(const Eigen::Matrix<float, 3, 3> &A, Eigen::Matrix<float, 3, 3> &Q, Eigen::Matrix<float, 3, 3> &R)
{
    Eigen::Matrix<float, 3, 3> A_ = syb3r::math::flipud<float, 3, 3>(A).transpose();
    Eigen::HouseholderQR<Eigen::Matrix<float, 3, 3>> qr(A_);
    Eigen::Matrix<float, 3, 3> R_ = qr.matrixQR().triangularView<Eigen::Upper>();

    R = syb3r::math::flipud<float, 3, 3>(syb3r::math::flipud<float, 3, 3>(R_).transpose());
    Q = syb3r::math::flipud<float, 3, 3>(qr.householderQ().transpose());
}

}}
