#ifndef SIMPLECAMERASENSORNOISE_H
#define SIMPLECAMERASENSORNOISE_H

#include "../tools/FloatImage.h"

namespace syb3r {
namespace models {

class SimpleCameraSensorNoise
{
    public:
        SimpleCameraSensorNoise(float blurSigma, const Eigen::Matrix3f &rgbToComponentVariance, const Eigen::Vector3f &componentVarianceOffset);
        void synthesizeNoise(tools::FloatImage<Eigen::Vector3f> &img, std::mt19937 &rng) const;
    protected:
        std::vector<float> m_filterKernel;
        Eigen::Matrix3f m_rgbToComponentVariance;
        Eigen::Vector3f m_componentVarianceOffset;
};

extern SimpleCameraSensorNoise eos400_1600;


}
}

#endif // SIMPLECAMERASENSORNOISE_H
