#ifndef CPUSTOPWATCH_H
#define CPUSTOPWATCH_H

#include <chrono>

namespace syb3r {
namespace tools {

/**
 * @brief Measures elapsed time
 */
class CPUStopWatch
{
    public:
        CPUStopWatch();

        /// Resets the clock
        void start();
        /// Returns the number of nano seconds that have passed since either object creation or the last call to start()
        /// @details The actual precision might my significantly less then nano seconds!
        uint64_t getNanoseconds();
    protected:
        std::chrono::time_point<std::chrono::steady_clock> m_start;
};

}
}

#endif // CPUSTOPWATCH_H
