#ifndef WRAPPERDFMSUBSBA_H
#define WRAPPERDFMSUBSBA_H

#include <syb3r/tools/ShellExec.h>

#include <string>
#include <vector>

namespace syb3r {

namespace data {
    class Dataset;
    class EstimatedCameraPath;
}

namespace wrapper {

class WrapperDFMSubsBA : protected tools::ShellExec
{
    public:
        std::string executable = "cmd_sfm";

        bool radialDistortion = false;
        bool sharedFocalLength = false;
        std::string pmvsOutputFolder;
        std::string xmlOutputFilename;

        bool runSFM(float focalLengthEstimate, const std::pair<unsigned, unsigned> &initialPair, const std::vector<std::string> &images, data::EstimatedCameraPath &estimatedCameraPath);

        static void parseCamerasFromXMLFile(const std::vector<std::string> &images, const std::string &xmlFilename, data::EstimatedCameraPath &estimatedCameraPath);
    protected:
        virtual void parseLine(const char *line) override;
};

}
}

#endif // WRAPPERDFMSUBSBA_H
