#ifndef WRAPPERPMVS_H
#define WRAPPERPMVS_H

#include <syb3r/tools/ShellExec.h>

#include <boost/optional.hpp>
#include <Eigen/Dense>

namespace syb3r {

namespace data {
    class Camera;
}

namespace wrapper {

class WrapperPMVS : protected tools::ShellExec
{
    public:
        std::string executable = "~/software/CMVS-PMVS/program/buildRelease/main/pmvs2";

        unsigned mipLevel = 1;
        boost::optional<unsigned> numImages;
        bool generateOptionsFile = false;

        bool runPreparedSet(const std::string &basePath, const std::string &optionsFilename, std::vector<Eigen::Vector3f> &pcld, std::vector<Eigen::Vector3f> *colors = nullptr);
        bool runUnpreparedSet(const std::vector<data::Camera> &calibration, const std::vector<std::string> &images, std::vector<Eigen::Vector3f> &pcld, std::vector<Eigen::Vector3f> *colors = nullptr);
    protected:
        virtual void parseLine(const char *line) override;

};

}
}

#endif // WRAPPERPMVS_H
