#ifndef WRAPPERVSFM_H
#define WRAPPERVSFM_H

#include <syb3r/tools/ShellExec.h>

#include <string>
#include <vector>

namespace syb3r {

namespace data {
    class Dataset;
    class EstimatedCameraPath;
}

namespace wrapper {

class WrapperVSFM : protected tools::ShellExec
{
    public:
        std::string executablePath = "~/software/vsfm/bin/";
        std::string executable = "./VisualSFM";

        bool hardlink = false;
        bool producePMVSOutput = false;

        std::string nvmOutputFilename;

        bool runSFM(const data::Dataset &dataset, const std::vector<std::string> &images, data::EstimatedCameraPath &estimatedCameraPath);

        static void parseCamerasFromNVMFile(const data::Dataset &dataset, const std::vector<std::string> &images, const std::string &nvmOutputFilename, data::EstimatedCameraPath &estimatedCameraPath);
    protected:
        virtual void parseLine(const char *line) override;
};

}
}

#endif // WRAPPERVSFM_H
