/*
 * Syb3r - A framework for the creation and use of synthetic benchmark datasets for SfM/MVS with Blender and Cycles.
 * Copyright (C) 2016 Andreas Ley <mail@andreas-ley.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#ifndef IMAGEPP_COLORMATRIX_H
#define IMAGEPP_COLORMATRIX_H

#include "ImagePostprocessorStep.h"

namespace syb3r {
namespace synthesis {

class ImagePP_ColorMatrix : public ImagePostprocessorStep
{
    public:
        static const Eigen::Matrix3f CanonEOS400_to_XYZ;
        static const Eigen::Matrix3f XYZ_to_sRGB;


        ImagePP_ColorMatrix(const Eigen::Matrix3f &colorMatrix);

        virtual void process(tools::FloatImage<Eigen::Vector3f> &output, const tools::FloatImage<Eigen::Vector3f> &input, ImageProperties &properties) const override;
    protected:
        Eigen::Matrix3f m_colorMatrix;
};

}
}

#endif // IMAGEPP_COLORMATRIX_H
