#ifndef _SYNTHBENCH_SCRIPTGENERATOR_H_
#define _SYNTHBENCH_SCRIPTGENERATOR_H_

#include <ostream>
#include <string>
#include <vector>

namespace syb3r {
namespace synthesis {

class ScripGenerator
{
    public:
        bool preview = false;

        enum ComputeDevice {
            COMPUTEDEVICE_GPU,
            COMPUTEDEVICE_CPU
        };
        ComputeDevice computeDevice = COMPUTEDEVICE_GPU;

        std::string outputDir = "/tmp/Syb3rScene/";
        std::string preRenderHook = "def preRenderHook(scene, type):\n    return\n\n";

        std::vector<std::string> cameras;

        bool renderHDR = true;
        bool renderAttribs = true;

        void generate(std::ostream &stream);
    protected:
};


}
}

#endif // _SYNTHBENCH_SCRIPTGENERATOR_H_